题解:CF1829H Don‘t Blame Me

一:思路:

在本题,我们可以先设dpi,j为选到第 i 个数时,按位与结果为 j 的方案数

接下来分两种情况分类讨论:

**- 如果不选:加上选到第 i−1 个数的方案数,也就是dpi,j = dpi,j + dpi-1,j

  • 如果选:与上第 i 个数,也就是:dp i,j & a i = dp i,j & ai + dp i-1,j**
  1. 由于题目给出的 k 表示二进制位有 k 个 1,那我们就要在 0-63 中找到所有二进制位中有 k 个 1 的数,并将方案数累加。

  2. 这里的方法找是二进制中有多少个 1,不停的与比当前数少 1 的数进行按位与,这样当目前的数变成 0 时,二进制位 1 的个数也就统计出来了。

代码:

cpp 复制代码
#include<bits/stdc++.h>
#define ll long long
using namespace std;
const int N=2e5+10,mod=1e9+7;
ll t,n,m,a[N];
ll dp[N][80];
ll ldnsbshljbl(ll x){
    ll cnt=0;
    while(x!=0){
        cnt++;
        x&=x-1;
    }
    return cnt;
    }
    int main(){
    scanf("%lld",&t);
    while(t--){
        scanf("%lld%lld",&n,&m);
        for(int i=1;i<=n;i++){
            scanf("%lld",&a[i]);
            for(int j=0;j<64;j++){
                dp[i][j]=0;
            }
            dp[i][a[i]]=1;
        }
        for(int i=1;i<=n;i++){
            for(int j=0;j<64;j++){
                dp[i][j]=(dp[i][j]+dp[i-1][j])%mod;
                dp[i][j&a[i]]=(dp[i][j&a[i]]+dp[i-1][j])%mod;
            }
        }
        ll ans=0;
        for(int i=0;i<64;i++){
            if(ldnsbshljbl(i)==m){
                ans=(ans+dp[n][i])%mod;
            }
        }
        printf("%lld\n",ans);
    }
    return 0;
}
相关推荐
程序 代码狂人4 分钟前
切片表与分区表的区别(数据开发面试版)
java·大数据·开发语言·数据仓库·算法
HDU-Dade40 分钟前
【校招笔试真题】简要介绍 Self-Attention 的前沿算法
人工智能·算法
小郎君6583 小时前
Vue keep-alive 切标签后滚动位置回顶?因为 onDeactivated 里读到的 scrollTop 是 0
算法
邵奈一3 小时前
GPT-6.1 Terra速度是Sol的3倍,价格减半
算法
RaaS1003 小时前
Node.js Brotli RCE 漏洞自查指南:fetch、undici、axios 都在影响面,三分钟确认你的版本
人工智能·深度学习·算法
shehuiyuelaiyuehao3 小时前
算法56,重排链表
数据结构·算法·链表
qq_452396234 小时前
第四篇:《索引原理与实战:B-tree、Hash、GIN、GiST、BRIN》
算法·哈希算法·gin
西索斯coding5 小时前
Qwen3-Max 与 Qwen-Plus:60 个真实修复任务评测方案
大数据·网络·算法·ai
INGNIGHT5 小时前
440 · 背包问题(三)(无限次数)
算法·leetcode·动态规划